Debian Bug report logs - #603036
lvm2: fails to install due to incorrect dependencies in init.d LSB header

version graph

Package: lvm2; Maintainer for lvm2 is Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>; Source for lvm2 is src:lvm2.

Reported by: Holger Levsen <holger@layer-acht.org>

Date: Wed, 10 Nov 2010 15:06:01 UTC

Severity: serious

Tags: patch, squeeze-ignore

Found in versions lvm2/2.02.66-4, lvm2/2.02.66-5

Fixed in versions lvm2/2.02.84-3, 2.02.84-3

Done: Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Wed, 10 Nov 2010 15:06:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Holger Levsen <holger@layer-acht.org>:
New Bug report received and forwarded. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Wed, 10 Nov 2010 15:06:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Holger Levsen <holger@layer-acht.org>
To: submit@bugs.debian.org
Subject: lvm2: fails to install due to incorrect dependencies in init.d LSB header
Date: Wed, 10 Nov 2010 16:03:15 +0100
[Message part 1 (text/plain, inline)]
Package: lvm2
Version: 2.02.66-4
Found: 2.02.66-3
Severity: serious
User: debian-qa@lists.debian.org
Usertags: piuparts piuparts.d.o
User:     initscripts-ng-devel@lists.alioth.debian.org
Usertags: incorrect-dependency

Hi, 

during a test with piuparts I noticed your package failed to install due to 
incorrect dependencies in the init.d LSB header. Some debian notes are 
available from at http://wiki.debian.org/LSBInitScripts

From the attached log (scroll to the bottom...):

  Unpacking lvm2 (from .../lvm2_2.02.66-3_amd64.deb) ...
  Setting up lvm2 (2.02.66-3) ...
  invoke-rc.d: policy-rc.d denied execution of start.
  insserv: Service udev has to be enabled to start service lvm2
  insserv: exiting now!
  update-rc.d: error: insserv rejected the script header
  dpkg: error processing lvm2 (--configure):
   subprocess installed post-installation script returned error exit status 1
  configured to not write apport reports
  Errors were encountered while processing:
   lvm2
  E: Sub-process /usr/bin/dpkg returned an error code (1)

Both the version in sid and squeeze are affected.


regards,
	Holger
[lvm2_2.02.66-3.log (text/x-log, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Mon, 06 Dec 2010 13:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tanguy Ortolo <tanguy+debian@ortolo.eu>:
Extra info received and forwarded to list. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Mon, 06 Dec 2010 13:03:03 GMT) Full text and rfc822 format available.

Message #10 received at 603036@bugs.debian.org (full text, mbox):

From: Tanguy Ortolo <tanguy+debian@ortolo.eu>
To: Holger Levsen <holger@layer-acht.org>, 603036@bugs.debian.org
Subject: Re: Bug#603036: lvm2: fails to install due to incorrect dependencies in init.d LSB header
Date: Mon, 6 Dec 2010 14:02:08 +0100
[Message part 1 (text/plain, inline)]
Le mercredi 10 novembre 2010, Holger Levsen a écrit :
> during a test with piuparts I noticed your package failed to install due to 
> incorrect dependencies in the init.d LSB header. Some debian notes are 
> available from at http://wiki.debian.org/LSBInitScripts
> 
> From the attached log (scroll to the bottom...):
>   invoke-rc.d: policy-rc.d denied execution of start.
>   insserv: Service udev has to be enabled to start service lvm2
>   insserv: exiting now!
>   update-rc.d: error: insserv rejected the script header
>   dpkg: error processing lvm2 (--configure):
>    subprocess installed post-installation script returned error exit status 1
>   configured to not write apport reports

I wonder if it is not simply because lvm2's init script depends on
udev's, whereas the package does not depend on the udev package. Thus it
is possible to install lvm2 without udev, which would make insserv fail
to satisfy this dependancy.

-- 
 ,--.
: /` )   Tanguy Ortolo <xmpp:tanguy@ortolo.eu> <irc://irc.oftc.net/Elessar>
| `-'    Theoretically Debian Maintainer
 \_
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Thu, 09 Dec 2010 19:09:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Thu, 09 Dec 2010 19:09:09 GMT) Full text and rfc822 format available.

Message #15 received at 603036@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: Tanguy Ortolo <tanguy+debian@ortolo.eu>, 603036@bugs.debian.org
Subject: Re: Bug#603036: lvm2: fails to install due to incorrect dependencies in init.d LSB header
Date: Thu, 9 Dec 2010 20:07:33 +0100
[Message part 1 (text/plain, inline)]
On Mon, 06 Dec 2010 14:02:08 +0100, Tanguy Ortolo wrote:

> >   invoke-rc.d: policy-rc.d denied execution of start.
> >   insserv: Service udev has to be enabled to start service lvm2
> >   insserv: exiting now!
> >   update-rc.d: error: insserv rejected the script header
> >   dpkg: error processing lvm2 (--configure):
> >    subprocess installed post-installation script returned error exit status 1
> >   configured to not write apport reports
> I wonder if it is not simply because lvm2's init script depends on
> udev's, whereas the package does not depend on the udev package. Thus it
> is possible to install lvm2 without udev, which would make insserv fail
> to satisfy this dependancy.

Sounds logical. And also works in a quick piuparts test.

What surprises me is the changelog entry for 2.02.64-1:
  * Enable udev sync, remove explicit udev dependency, bump dmsetup dependency
    to get it working. (closes: #543163)

The question is if udev is necessary; if not it probably can be moved
from Default-Start to Should-Start in the init script.
 
I've also tried this and it also works.


Cheers,
gregor 
-- 
 .''`.   http://info.comodo.priv.at/ -- GPG key IDs: 0x8649AA06, 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT & SPI, fellow of Free Software Foundation Europe
   `-    NP: Vic Chesnutt: Gravity Of The Situation
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Mon, 13 Dec 2010 20:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Mon, 13 Dec 2010 20:39:03 GMT) Full text and rfc822 format available.

Message #20 received at 603036@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: 603036@bugs.debian.org
Subject: Re: lvm2: fails to install due to incorrect dependencies in init.d LSB header
Date: Mon, 13 Dec 2010 21:35:36 +0100
tags 603036 + patch
thanks

There are two ways to fix this issue.  One is to change the package
dependencies of lvm2 to depend on udev, the other is to change the
init.d script dependency on udev from a hard to a soft dependency.

Hard dependencies are required when the package is installed, while
soft dependencies only define ordering if the two packages in question
are both installed.

I believe switching to a soft dependency is the correct solution, as
the package relations receive more though in Debian these days than
the init.d script relations.

Here is a patch to implement this change.

--- debian/lvm2.init.orig       2010-12-13 21:30:44.000000000 +0100
+++ debian/lvm2.init    2010-12-13 21:30:58.000000000 +0100
@@ -1,9 +1,9 @@
 #!/bin/sh
 ### BEGIN INIT INFO
 # Provides:          lvm2 lvm
-# Required-Start:    mountdevsubfs udev
+# Required-Start:    mountdevsubfs
 # Required-Stop:
-# Should-Start:      mdadm-raid cryptdisks-early multipath-tools-boot
+# Should-Start:      udev mdadm-raid cryptdisks-early multipath-tools-boot
 # Should-Stop:       umountroot mdadm-raid
 # X-Start-Before:    checkfs mountall
 # X-Stop-After:      umountfs

Given that udev is installed on most Debian systems, it can be argued
that this issue is not release critical.  I expect incorrect udev
relationship to be RC for kfreebsd but given that lvm2 do not work on
kfreebsd, it is purely ac itademic in this case.

Happy hacking,
-- 
Petter Reinholdtsen




Added tag(s) patch. Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. (Mon, 13 Dec 2010 20:39:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Sun, 26 Dec 2010 23:09:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Sun, 26 Dec 2010 23:09:10 GMT) Full text and rfc822 format available.

Message #27 received at 603036@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Petter Reinholdtsen <pere@hungry.com>, 603036@bugs.debian.org
Subject: Re: Bug#603036: lvm2: fails to install due to incorrect dependencies in init.d LSB header
Date: Mon, 27 Dec 2010 00:06:20 +0100
[Message part 1 (text/plain, inline)]
user release.debian.org@packages.debian.org
usertag 603036 squeeze-can-defer
tag 603036 squeeze-ignore
kthxbye

On Mon, Dec 13, 2010 at 21:35:36 +0100, Petter Reinholdtsen wrote:

> Given that udev is installed on most Debian systems, it can be argued
> that this issue is not release critical.  I expect incorrect udev
> relationship to be RC for kfreebsd but given that lvm2 do not work on
> kfreebsd, it is purely ac itademic in this case.
> 
Agreed, I won't make this a blocker for squeeze.  A fix would still be
welcome though.

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Added tag(s) squeeze-ignore. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Sun, 26 Dec 2010 23:09:13 GMT) Full text and rfc822 format available.

Bug Marked as found in versions lvm2/2.02.66-5. Request was from Holger Levsen <holger@layer-acht.org> to control@bugs.debian.org. (Sat, 16 Jul 2011 07:45:14 GMT) Full text and rfc822 format available.

Bug Marked as fixed in versions lvm2/2.02.84-3. Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Mon, 25 Jul 2011 17:45:02 GMT) Full text and rfc822 format available.

Reply sent to Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>:
You have taken responsibility. (Fri, 04 May 2012 13:03:26 GMT) Full text and rfc822 format available.

Notification sent to Holger Levsen <holger@layer-acht.org>:
Bug acknowledged by developer. (Fri, 04 May 2012 13:03:33 GMT) Full text and rfc822 format available.

Message #38 received at 603036-done@bugs.debian.org (full text, mbox):

From: Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>
To: 603036-done@bugs.debian.org
Subject: lvm2: fails to install due to incorrect dependencies in init.d LSB header
Date: Fri, 04 May 2012 14:00:57 +0100
[Message part 1 (text/plain, inline)]
Version: 2.02.84-3

This bug was fixed in the past upload, but the bug was left open.
Closing.

-- 
Regards,
Dmitrijs.

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Thu, 20 Sep 2012 07:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Thu, 20 Sep 2012 07:48:03 GMT) Full text and rfc822 format available.

Message #43 received at 603036@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: 603036@bugs.debian.org
Subject: Fwd: pu: package lvm/2.02.66-5.1
Date: Thu, 20 Sep 2012 09:46:58 +0200
[Message part 1 (text/plain, inline)]
The pu request is #687761
http://bugs.debian.org/687761

-------- Original Message --------
Subject: pu: package lvm/2.02.66-5.1
Date: Sat, 15 Sep 2012 17:03:48 +0200
From: Andreas Beckmann <debian@abeckmann.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>

Package: release.debian.org
Severity: normal
User: release.debian.org@packages.debian.org
Usertags: pu

Hi,

I've prepared a NMU for lvm that fixes #603036: "lvm2: fails to install
due to incorrect dependencies in init.d LSB header"

The bug is tagged squeeze-ignore:
On Monday, 27. December 2010 00:06:20 Julien Cristau wrote:
> On Mon, Dec 13, 2010 at 21:35:36 +0100, Petter Reinholdtsen wrote:
> > Given that udev is installed on most Debian systems, it can be
> > argued
> > that this issue is not release critical.  I expect incorrect udev
> Agreed, I won't make this a blocker for squeeze.  A fix would still be
> welcome though.

I'm just adding the udev dependency to the lvm2 package, not touching
the initscript (which has been updated for wheezy to make udev
optional). This just makes the current situation (udev has to be
installed for lvm to work) explicit.

This bug is a bit annoying for piuparts because we need to work around
this for lvm2 and its rdepends, therefore I'd like to see this fixed.

If this request is confirmed, I'll go looking for a sponsor.


Andreas

PS: I just noticed, the version should probably be 2.02.66-5+squeeze1

[lvm2_2.02.66-5.1.nmudiff (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Thu, 20 Sep 2012 07:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Adam D. Barratt" <adam@adam-barratt.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Thu, 20 Sep 2012 07:51:03 GMT) Full text and rfc822 format available.

Message #48 received at 603036@bugs.debian.org (full text, mbox):

From: "Adam D. Barratt" <adam@adam-barratt.org.uk>
To: Andreas Beckmann <debian@abeckmann.de>, 687761@bugs.debian.org
Subject: Re: Bug#687761: pu: package lvm/2.02.66-5.1
Date: Wed, 19 Sep 2012 21:55:16 +0100
On Sat, 2012-09-15 at 17:03 +0200, Andreas Beckmann wrote:
> I've prepared a NMU for lvm that fixes #603036: "lvm2: fails to install
> due to incorrect dependencies in init.d LSB header"
[...]
> I'm just adding the udev dependency to the lvm2 package, not touching
> the initscript (which has been updated for wheezy to make udev
> optional). This just makes the current situation (udev has to be
> installed for lvm to work) explicit.

As a rule of thumb, we generally prefer taking the fixes used in
unstable where they're applicable, as they've (in theory) been better
tested.

Please could you expand a little on why you feel adding the dependency
would be a better solution than making the use of udev optional via the
LSB headers as (as you noted) was done for wheezy?

Regards,

Adam




Information forwarded to debian-bugs-dist@lists.debian.org, Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>:
Bug#603036; Package lvm2. (Thu, 20 Sep 2012 07:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>. (Thu, 20 Sep 2012 07:51:05 GMT) Full text and rfc822 format available.

Message #53 received at 603036@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: "Adam D. Barratt" <adam@adam-barratt.org.uk>, 603036@bugs.debian.org, 687761@bugs.debian.org
Subject: Re: Bug#687761: pu: package lvm/2.02.66-5.1
Date: Thu, 20 Sep 2012 09:48:35 +0200
On 2012-09-19 22:55, Adam D. Barratt wrote:
> Please could you expand a little on why you feel adding the dependency
> would be a better solution than making the use of udev optional via the
> LSB headers as (as you noted) was done for wheezy?

I do not know the lvm2 package well enough to judge whether "fixing the
initscript" is a safe solution for squeeze (or if there are some other
implicit dependencies relying on the current setup) and if there may
have been other related fixes in wheezy. So I did not want to touch the
initscript dependency graph in squeeze (i.e. removing an edge). Instead
I thought explicitly adding the package dependency that currently makes
lvm2 "just work" out of the box should have less potential to cause
problems.

I just forwarded the thread to #603036 (that I want to get fixed),
perhaps the maintainers have some more input on this. Looks like I
missed to set a proper X-Debbugs-Cc initially ...


Andreas



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 05 May 2013 07:40:56 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 17:33:11 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.